//
//  ActionMO.h
//
//  Created by Paul Herzog
//  Copyright 2007 MacSpeech, Inc. All rights reserved.
//
#import "_ActionMO.h"

@class SEReference;
@class SEApplication;
@class ASDefaultApplication;
@class OSAScript;

@interface ActionMO : _ActionMO {}

#pragma mark
#pragma mark Accessors
- (NSAttributedString *)displayText;
- (void)setDisplayText:(NSAttributedString *)attributedText;

#pragma mark
#pragma mark Support
- (NSAttributedString *)attributedTextForAppleScript;
- (BOOL)compileAppleScript;

#pragma mark
#pragma mark Execute Dispatcher
- (BOOL)execute;

#pragma mark
#pragma mark Execute Actions
- (BOOL)executeAppleScript;
- (OSAScript *)scriptUsingCompiledData:(BOOL)useCompileData;
- (BOOL)executeTextPaste;
- (BOOL)executeOpenAlias;
//- (BOOL)executeImagePaste;
- (BOOL)executeOpenURL;
- (BOOL)executeShellScript;
- (BOOL)executeLaunchApplication;
- (NSString *)tempFileName;

#pragma mark
#pragma mark MenuItem Execution
- (BOOL)executeMenuItem;
- (void)autoClickMenuItem:(NSDictionary *)menuInfo;
- (void)clickMenuItem:(NSDictionary *)menuInfo withSystemEvents:(SEApplication *)systemEvents;
- (ASDefaultApplication *)activateAppWithBundleIdentifier:(NSString *)bundleIdentifier;
- (SEReference *)menuItemNamed:(NSString *)menuName fromMenu:(NSArray *)menuList;
- (SEReference *)menuNamed:(NSString *)menuName fromMenuBarRef:(SEReference *)menuBarRef;
- (SEReference *)activeAppFromList:(SEReference *)processList;
- (void)alertUnavailableComponent:(NSString *)menuComponent ofMenuPath:(NSString *)menuPath;
- (void)alertDisabledMenuPath:(NSString *)menuPath;
- (void)alertMenuItemFailureMessage:(NSString *)message;

#pragma mark -
#pragma mark Workflow Execution
- (BOOL)executeWorkflow;
- (NSString *)automatorLauncher;
- (NSString *)pathForAutomatorRunner;
- (NSString *)scriptTextForWorkflow:(NSString *)workflowPath;
- (BOOL)useAppleScriptToLaunchWorkflow:(NSString *)workflowPath;

- (void)showData:(NSData *)compiledData named:(NSString *)dataName;
@end
